package gestionale;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;

public class Main {

	public static void main(String[] args) {
		GestionaleImmagini g = new GestionaleImmagini();
		JFrame f = new JFrame();
		JButton scegliImmagine = new JButton("Carica immagine");
		JPanel left = new JPanel();
		left.setLayout(new BoxLayout(left,BoxLayout.PAGE_AXIS));
		left.add(scegliImmagine);
		JScrollPane scroll = new JScrollPane(left);
		PannelloImmagine right = new PannelloImmagine();
		JSplitPane splitPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, scroll, right);
		splitPane.setDividerSize(0);
		splitPane.setDividerLocation(200);
		f.add(splitPane);
		f.setSize(800, 800);
		f.setMinimumSize(new Dimension(400,400));
		
		scegliImmagine.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				JFileChooser f = new JFileChooser();
				int res = f.showOpenDialog(null);
				if(res == JFileChooser.APPROVE_OPTION) {
					File file = f.getSelectedFile();
					String etichetta = JOptionPane.showInputDialog("Scegli un'etichetta per l'immagine");
					BufferedImage img = null;
				    try {
						img = ImageIO.read(file);						
						Immagine i = g.aggiungiImmagine(etichetta, img);
						i.addMouseListener(new MouseListener() {
							
							@Override
							public void mouseReleased(MouseEvent e) {
							}
							
							@Override
							public void mousePressed(MouseEvent e) {
								right.cambiaSfondo(i);
							}
							
							@Override
							public void mouseExited(MouseEvent e) {
							}
							
							@Override
							public void mouseEntered(MouseEvent e) {
							}
							
							@Override
							public void mouseClicked(MouseEvent e) {
							}
						});
						left.add(i);
						left.repaint();
						left.revalidate();						
					} catch (IOException e1) {
						e1.printStackTrace();
					}	
				}
			}
		});
		f.setVisible(true);
		f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);		
	}
}
