package snake.core;

import java.util.ArrayList;

public class GestoreMovimento {

	private final static int velocita = 10;
	public final static int MUOVI_DESTRA = 0;
	public final static int MUOVI_SINISTRA = 1;
	public final static int MUOVI_SOPRA = 2;
	public final static int MUOVI_SOTTO = 3;

	private static boolean collisione(Serpente s, ArrayList<Erba> erba) {
		return (erba.contains(s.getTesta()) || s.getCorpo().contains(s.getTesta()));
	}

	private static void muoviTesta(int direzione, Serpente s) {
		Blocco b = s.getTesta();
		switch (direzione) {
		case MUOVI_DESTRA:
			b.x += velocita;
			break;

		case MUOVI_SINISTRA:
			b.x -= velocita;
			break;

		case MUOVI_SOPRA:
			b.y -= velocita;
			break;

		case MUOVI_SOTTO:
			b.y += velocita;
			break;
		}
	}

	private static void muoviCorpo(Serpente s, int x, int y) {
		ArrayList<Blocco> corpo = s.getCorpo();
		if (corpo.isEmpty())
			return;
		for (int i = corpo.size() - 1; i >= 1; i--) {
			muovi(corpo.get(i), corpo.get(i - 1));
		}
		muovi(corpo.get(0),new Blocco(x, y));
	}

	private static void muovi(Blocco partenza, Blocco arrivo) {
		partenza.x = arrivo.x;
		partenza.y = arrivo.y;
	}

	public static boolean muovi(int direzione, Serpente s, ArrayList<Erba> erba) {
		int vecchia_x = s.getTesta().x;
		int vecchia_y = s.getTesta().y;
		muoviTesta(direzione, s);
		muoviCorpo(s, vecchia_x, vecchia_y);
		if (collisione(s, erba))
			return false;
		return true;
	}

	public static boolean raggiuntoBlocco(Serpente ser, Blocco b) {
		return ser.getTesta().equals(b);
	}
}
