package snake.core;

import java.util.ArrayList;
import java.util.Random;

import snake.config.Impostazioni;

public class Snake {

	Serpente serpente;
	ArrayList<Erba> erba;
	Blocco b;
	boolean vivo;

	public Snake() {
		serpente = new Serpente();
		erba = new ArrayList<Erba>();
		b = null;
		vivo = true;
		generaErba();
	}

	public ArrayList<Erba> getErba() {
		return erba;
	}

	private void generaErba() {
		if (!erba.isEmpty())
			return;
		for (int i = 0; i < Impostazioni.DIMENSIONE_FINESTRA; i += Impostazioni.DIMENSIONE_BLOCCO) {
			erba.add(new Erba(i, 0));
			erba.add(new Erba(i, Impostazioni.DIMENSIONE_FINESTRA - Impostazioni.DIMENSIONE_BLOCCO));
		}
		for (int i = 0; i < Impostazioni.DIMENSIONE_FINESTRA; i += Impostazioni.DIMENSIONE_BLOCCO) {
			erba.add(new Erba(0, i));
			erba.add(new Erba(Impostazioni.DIMENSIONE_FINESTRA - Impostazioni.DIMENSIONE_BLOCCO, i));
		}
	}

	public Blocco generaBlocco() {
		Random r = new Random();
		Blocco tmp;
		do {
			// per ottenere una posizione in blocchi divisibili per
			// Impostazioni.DIMENSIONE_BLOCCO
			int x = (r.nextInt(Impostazioni.DIMENSIONE_FINESTRA) / Impostazioni.DIMENSIONE_BLOCCO)
					* Impostazioni.DIMENSIONE_BLOCCO;
			int y = (r.nextInt(Impostazioni.DIMENSIONE_FINESTRA) / Impostazioni.DIMENSIONE_BLOCCO)
					* Impostazioni.DIMENSIONE_BLOCCO;
			tmp = new Blocco(x, y);
		} while (erba.contains(tmp) || serpente.contiene(tmp));
		return tmp;
	}

	public Blocco getBlocco() {
		if (b == null)
			b = generaBlocco();
		return b;
	}

	public Serpente getSerpente() {
		return serpente;
	}

	public boolean isVivo() {
		return vivo;
	}

	public void muovi(int direzione) {
		boolean ret = GestoreMovimento.muovi(direzione, serpente, erba);
		if (!ret) {
			vivo = false;
		} else if (GestoreMovimento.raggiuntoBlocco(serpente, b)) {
			serpente.aggiungi(b);
			b = null;
		}
	}
}
